Unit afh5z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA01Z_p;

procedure afh5z(NM :Integer; N :Integer; var A :Array of Extended;
                var D :Array of Extended; var E :Array of Extended;
                var E2 :Array of Extended; var TAU :Array of Extended);

implementation

procedure afh5z(NM :Integer; N :Integer; var A :Array of Extended;
                var D :Array of Extended; var E :Array of Extended;
                var E2 :Array of Extended; var TAU :Array of Extended);
var
I,II,J,JM1,JP1,K,L :Integer;
F,FI,G,GI,H,HH,SCALE,SI :Extended;
const
SYS056 :Extended = 1.381786968815111e-76;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180;
begin
TAU[0+(N-1)*2] := 1.0e0;
TAU[1+(N-1)*2] := 0.0e0;
{      I=N,1,-1 }
for II:=1 to N do
 begin
  I := N + 1 - II;
  L := I - 1;
  H := 0.0e0;
  SCALE := 0.0e0;
  if ( L <  1 ) 
   then goto _30;
{      HOPMPOBKA CTPOK }
  for K:=1 to L do
   begin
    SCALE := SCALE + Abs(A[(I-1)+(K-1)*NM]) + Abs(A[(K-1)+(I-1)*NM]);
_10:
   end;
  if ( SCALE >=  SYS056 ) 
   then goto _40;
  TAU[0+(L-1)*2] := 1.0e0;
  TAU[1+(L-1)*2] := 0.0e0;
  for K:=1 to L do
   begin
    A[(I-1)+(K-1)*NM] := 0.e0;
    A[(K-1)+(I-1)*NM] := 0.e0;
_20:
   end;
_30:
  E[I-1] := 0.0e0;
  E2[I-1] := 0.0e0;
  goto _170;
_40:
  for K:=1 to L do
   begin
    A[(I-1)+(K-1)*NM] := A[(I-1)+(K-1)*NM]/SCALE;
    A[(K-1)+(I-1)*NM] := A[(K-1)+(I-1)*NM]/SCALE;
    H := H + A[(I-1)+(K-1)*NM]*A[(I-1)+(K-1)*NM] + A[(K-1)+(I-1)*NM]*A[(K-1)+(I-1)*NM];
_50:
   end;
  E2[I-1] := SCALE*SCALE*H;
  G := Sqrt(H);
  E[I-1] := SCALE*G;
  F := AA01Z(A[(I-1)+(L-1)*NM],A[(L-1)+(I-1)*NM]);
{  OPM-E CEYEO A.EMEHTA MATP T }
  if ( F <=  SYS056 ) 
   then goto _60;
  TAU[0+(L-1)*2] := (A[(L-1)+(I-1)*NM]*TAU[1+(I-1)*2] - A[(I-1)+(L-1)*NM]*TAU[0+(I-1)*2])/F;
  SI := (A[(I-1)+(L-1)*NM]*TAU[1+(I-1)*2] + A[(L-1)+(I-1)*NM]*TAU[0+(I-1)*2])/F;
  H := H + F*G;
  G := 1.0e0 + G/F;
  A[(I-1)+(L-1)*NM] := G*A[(I-1)+(L-1)*NM];
  A[(L-1)+(I-1)*NM] := G*A[(L-1)+(I-1)*NM];
  if ( L =  1 ) 
   then goto _150;
  goto _70;
_60:
  TAU[0+(L-1)*2] := -TAU[0+(I-1)*2];
  SI := TAU[1+(I-1)*2];
  A[(L-1)+(I-1)*NM] := 0.e0;
  A[(I-1)+(L-1)*NM] := G;
_70:
  F := 0.0e0;
  for J:=1 to L do
   begin
    G := 0.0e0;
    GI := 0.0e0;
    if ( J =  1 ) 
     then goto _90;
    JM1 := J - 1;
{  OPM-E A*U }
    for K:=1 to JM1 do
     begin
      G := G + A[(J-1)+(K-1)*NM]*A[(I-1)+(K-1)*NM] + A[(K-1)+(J-1)*NM]*A[(K-1)+(I-1)*NM];
      GI := GI - A[(J-1)+(K-1)*NM]*A[(K-1)+(I-1)*NM] + A[(K-1)+(J-1)*NM]*A[(I-1)+(K-1)*NM];
_80:
     end;
_90:
    G := G + A[(J-1)+(J-1)*NM]*A[(I-1)+(J-1)*NM];
    GI := GI - A[(J-1)+(J-1)*NM]*A[(J-1)+(I-1)*NM];
    JP1 := J + 1;
    if ( L <  JP1 ) 
     then goto _110;
    for K:=JP1 to L do
     begin
      G := G + A[(K-1)+(J-1)*NM]*A[(I-1)+(K-1)*NM] - A[(J-1)+(K-1)*NM]*A[(K-1)+(I-1)*NM];
      GI := GI - A[(K-1)+(J-1)*NM]*A[(K-1)+(I-1)*NM] - A[(J-1)+(K-1)*NM]*A[(I-1)+(K-1)*NM];
_100:
     end;
{  OPM-E P }
_110:
    E[J-1] := G/H;
    TAU[1+(J-1)*2] := GI/H;
    F := F + E[J-1]*A[(I-1)+(J-1)*NM] - TAU[1+(J-1)*2]*A[(J-1)+(I-1)*NM];
_120:
   end;
  HH := F/(H + H);
{  PEOPAOBAHE MACCBA A }
  for J:=1 to L do
   begin
    F := A[(I-1)+(J-1)*NM];
    G := E[J-1] - HH*F;
    E[J-1] := G;
    FI := -A[(J-1)+(I-1)*NM];
    GI := TAU[1+(J-1)*2] - HH*FI;
    TAU[1+(J-1)*2] := -GI;
    A[(J-1)+(J-1)*NM] := A[(J-1)+(J-1)*NM] - 2.0e0*(F*G + FI*GI);
    if ( J =  1 ) 
     then goto _140;
    JM1 := J - 1;
    for K:=1 to JM1 do
     begin
      A[(J-1)+(K-1)*NM] := A[(J-1)+(K-1)*NM] - F*E[K-1] - G*A[(I-1)+(K-1)*NM] + FI*TAU[1+(K-1)*2]
    + GI*A[(K-1)+(I-1)*NM];
      A[(K-1)+(J-1)*NM] := A[(K-1)+(J-1)*NM] - F*TAU[1+(K-1)*2] - G*A[(K-1)+(I-1)*NM] - FI*
    E[K-1] - GI*A[(I-1)+(K-1)*NM];
_130:
     end;
_140:
   end;
_150:
  for K:=1 to L do
   begin
    A[(I-1)+(K-1)*NM] := SCALE*A[(I-1)+(K-1)*NM];
    A[(K-1)+(I-1)*NM] := SCALE*A[(K-1)+(I-1)*NM];
_160:
   end;
  TAU[1+(L-1)*2] := -SI;
_170:
  D[I-1] := A[(I-1)+(I-1)*NM];
  A[(I-1)+(I-1)*NM] := SCALE*Sqrt(H);
_180:
 end;
end;

end.
